/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc structs.c  -o test.x -Wall 

// #pointers to struct


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary

struct student {
	char name[10];
	int id;
	float grade;
};

int printstructptr(struct student *);


int main(int argc, char *argv[] )
{

	struct student students[2];
	struct student *Alice; //pointer to a struct

	//"students" is also a pointer to the first struct in the array
	Alice = students;

	//now we access components with [pointer]->[component]
	sprintf(Alice->name, "Alice");
	Alice->id = 12345;
	Alice->grade = 2.5;

	printf("student %s (ID %d): %.1f\n", Alice->name, Alice->id, Alice->grade);


	sprintf(students[1].name, "Bob");
	students[1].id = 54321;
	students[1].grade = 3.0;

	struct student *Bob;
	Bob = students+1; //pointer arithmetic still works
	printstructptr(Bob);
	printf("new grade %.1f\n", Bob->grade);

   return( 0 );
}




int printstructptr(struct student *s)
{
	printf("student %s (ID %d): %.1f\n", s->name, s->id, s->grade);
	s->grade = 1.0;
   return( 0 );
}


