/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc structs.c  -o test.x -Wall 

// #structs


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary

//define what our struct looks like
struct student {
	char name[10];
	int id;
	float grade;
};

int printstruct(struct student);


int main(int argc, char *argv[] )
{

	struct student Alice; //declare just like any other variable
	//access components with [name].[component]
	sprintf(Alice.name, "Alice");
	Alice.id = 12345;
	Alice.grade = 2.5;

	//printf("student %s (ID %d): %.1f\n", Alice.name, Alice.id, Alice.grade);
	printstruct(Alice);


	//array of structs
	struct student students[2];

	sprintf(students[0].name, "Alice");
	students[0].id = 12345;
	students[0].grade = 2.5;

	sprintf(students[1].name, "Bob");
	students[1].id = 54321;
	students[1].grade = 3.0;

	for(int i=0; i<2; i++){
		printf("student %s (ID %d): %.1f\n", students[i].name, students[i].id, students[i].grade);
		printstruct(students[i]);
	}

   return( 0 );
}




int printstruct(struct student s)
{
	printf("student %s (ID %d): %.1f\n", s.name, s.id, s.grade);

   return( 0 );
}


